/*********************************************************************
*	AFEDRI SDR-Net Commander utility
*	Author: Alexander Trushkin ( 4Z5LV )
*	Date: 6.11.2013
*	
*	This utility allows you to control AFEDRI SDR 
*	over USB connection.
*	So you can use this utility in command shell scripts or WebSDR
*	or in crone command   
**********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
//#include <io.h>
//#include <conio.h>
#include <ctype.h>
#include "hidapi.h"
#include "fe_interface.h"
#include "commands.h"

#ifndef TRUE
	#define TRUE 1
#endif
#ifndef FALSE
	#define FALSE 0
#endif
#define SIZE_OF_WCHAR_BUF 256
int main(int argc, char **argv)
{
int RF_Gain = 0;
int FE_Gain = 0;
unsigned long tmp = 0;
int error = 0;
int arg;
int device_init_state = 0;
char tmp_path_name[256];
wchar_t *serial = NULL;
#ifndef __linux__
//	wchar_t tmp_serial[SIZE_OF_WCHAR_BUF]=L"\0";
#endif
	//	memset(tmp_serial,0,sizeof(tmp_serial));
	MSD_Envy_Init();
	Set_USB_Serial_number((wchar_t*)NULL);
    memset(tmp_path_name,0, sizeof(tmp_path_name));
	if(argc > 1)
	{
		for(arg = 1; arg < argc;arg++)
		{
			if (argv[arg][0] == '-')
			{
				
				switch(toupper(argv[arg][1]))
				{					
					case 'L':				/* verbose */
						enumerate_afedri_devs();
						break;
					case 'P':
//						printf("read path: ");
						sscanf(&argv[arg][2], "%s", tmp_path_name);
						if (tmp_path_name == 0)
						{
					 		printf("wrong path!\r\n");
						}
						else
						{
							SetMSDPath(tmp_path_name);
//							printf("%s %i \r\n",tmp_path_name, strlen(tmp_path_name));
						}
						break;
					case 'N':
						sscanf(&argv[arg][2], "%s", tmp_path_name);
						if (tmp_path_name == 0)
						{
					 		printf("No device serial number!\r\n");
							serial = NULL;
						}
						else
						{
	#ifdef __linux__
							serial = (wchar_t *) memalign(sizeof(wchar_t), SIZE_OF_WCHAR_BUF);
							mbstowcs (serial, tmp_path_name, strlen(tmp_path_name));
	#else
							serial = (wchar_t *) __mingw_aligned_malloc(sizeof(wchar_t), SIZE_OF_WCHAR_BUF);
							mbstowcs (serial, tmp_path_name, strlen(tmp_path_name));
//							serial = tmp_serial;
	#endif
							serial[strlen(tmp_path_name)] = L'\0';
							Set_USB_Serial_number(serial);
	#ifdef __linux__
							free(serial);
	#else
							__mingw_aligned_free(serial);
	#endif
						}
						break;
				}
			}
		}

		error = initialize_hardware();
		if(error == -1) 
		{
			printf("Cannot open AFEDRI SDR!\n\r");
//			device_init_state = 1;
			return -1;
		}

	}
	else
	{
		show_help_information();
		printf("Nothing To Do, please write the command to SDR! \n\r")	;
		return -2;
	}
	for (arg = 1; arg < argc; arg++)
	{
		if (argv[arg][0] == '-')
		{
			switch(toupper(argv[arg][1]))
			{
			case 'F':	/* set reception frequency */
//				if(device_init_state) break;
				if (sscanf(&argv[arg][2], "%ld", &tmp) != 1)
					error = TRUE;
				if (tmp == 0) error = TRUE;
				else set_rx_frequency(tmp);
				break;
			case 'M':	/* save Main Clock frequency */
//				if(device_init_state) break;
				if (sscanf(&argv[arg][2], "%ld", &tmp) != 1)
					error = TRUE;
				if(tmp > 50000000) 	save_main_clock_freq(tmp);
				else printf("The Main Clock value is too low!\r\n");
				break;
			case 'S':	/* save USB sample rate */
//				if(device_init_state) break;
				if (sscanf(&argv[arg][2], "%ld", &tmp) != 1)
					error = TRUE;
				if (tmp < 48000 )//|| tmp > 250000)
				{ 
					error = TRUE;
				}
				else
				{
					save_usb_sample_rate(tmp);
				}
			case 'R':	/* Soft Reset SDR */
//				if(device_init_state) break;
				reset_sdr();
				printf("Please Wait till SDR will be restarted again \n\r");
				return 0;
			case 'G': //Set RF gain			
//				if(device_init_state) break;
				if (sscanf(&argv[arg][2], "%d", &RF_Gain) != 1)
					error = TRUE;
				set_rf_gain(RF_Gain);
				break;
			case 'I': //Set RF gain	indexed from 0 to 15
//				if(device_init_state) break;
				if (sscanf(&argv[arg][2], "%d", &RF_Gain) != 1)
					error = TRUE;
				set_rf_gain_indexed(RF_Gain);
				break;
			case 'E': //Set FE gain			
//				if(device_init_state) break;
				if (sscanf(&argv[arg][2], "%d", &FE_Gain) != 1)
					error = TRUE;
				set_fe_gain(FE_Gain);
				break;

			case 'H':				/* help */
				show_help_information();
				break;

			case 'U': //Set RF gain	indexed from 0 to 15
//				if(device_init_state) break;
				if (sscanf(&argv[arg][2], "%d", &tmp) != 1)
					error = TRUE;
				set_usb_mode(tmp);
				break;
			case 'V':				/* verbose */
//				if(device_init_state) break;
				Get_SDR_Information();
				break;
			case 'D':				/* Save default settings */
//				if(device_init_state) break;
				save_defaults();
				break;

			default:
				break;
			}
		}
	}
	//if(device_init_state)
	HID_Close();
	return 0;
}